// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
      }
    },
    
    // Define elements within the ui configuration...
    nodes() {
      return [
       
        // any ui component node can be used...
        window.components.page(this.ctx.globals.getPermissions(['themeSettingsRead'])).append(() => [
          window.components.breadcrumbs([
            {
              label: this.$t('settings'),
              to: '/settings'
            },
            {
              label: this.$t('themes'),
              to: '/settings/themes'
            }
          ]),
          window.components.bar('themesSettings'),
          window.components.section().attrs({ class: 'flex justify-center' }).append(() => [
            window.components.card().attrs({ flat: false, class: 'full-width', style: { maxWidth: '1200px' }}).append(() => [
              window.components.element('NgTheme'),
            ]),
          ])
        ])
      ]
    },
  }
})