// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    props: ['markdown', 'design', 'item', 'computedObject', 'panel'],
    icon: 'mdi-file',

    config: {
      startPanel: 'properties',
      panels: [
        {
          header: 'properties',
          name: 'properties',
          items: [
            {
              type: 'form',
              props: {
                scope: 'data',
                schema: [
                  {
                    type: 'text',
                    default: '',
                    label: 'Src',
                    scope: 'attrs.src',
                    col: 'col-12',
                    dataTransferTypeKey: 'type',
                    dataTransferValueKey: 'ident',
                    dataTransferType: 'file',
                    sideSlot: 'link',
                    hint: '.pdf .csv .xlsx .md .json',
                  },
                  {
                    type: 'text',
                    default: '75vh',
                    label: 'height',
                    scope: 'attrs.height',
                    col: 'col-6',
                  },
                  {
                    type: 'text',
                    default: '100%',
                    label: 'width',
                    scope: 'attrs.width',
                    col: 'col-6',
                    "call.hidden": "(ctx.data.attrs.src.includes('.csv') || ctx.data.attrs.src.includes('.xlsx'))",
                  },
                  {
                    type: 'number',
                    default: 100,
                    label: 'cell',
                    scope: 'attrs.cellWidth',
                    col: 'col-6',
                    "call.hidden": "!(ctx.data.attrs.src.includes('.csv') || ctx.data.attrs.src.includes('.xlsx'))",
                  },
                  {
                    type: 'permissions',
                    default: [],
                    label: 'readPermissions',
                    hint: 'readPermissionsDescription',
                    scope: 'rights.read',
                    col: 'col-12',
                  },
                ],
              },
            },
          ],
        },
      ],
    },
    data() {
      return {
        carousel: false,
      };
    },
    // Define elements within the ui configuration...
    nodes() {
      return [
        {
          type: 'NgMedia',
          props: {
            ...this.item.attrs,
          },
          children: {
            default: (slot) => {
              return [
                // child nodes or string content
              ];
            },
          },
        },
        // any ui component node can be used...
      ];
    },
  };
});
