// Call ngui function to create a ui config.
window.ngui(() => {
  return {
      props: [
      'markdown',
      'design',
      'item',
      'computedObject',
      'panel',
    ],
    icon: 'mdi-image',

        config: {
      startPanel: 'properties',
      panels: [
        {
          header: 'properties',
          name: 'properties',
          items: [
            {
              type: 'form',
              props: {
                scope: 'data',
                schema: [
                  {
                    type: 'checkbox',
                    default: false,
                    label: 'Carousel',
                    scope: 'attrs.carousel',
                    "call.onUpdate": "(val) => { ctx.data.attrs.carousel = val; const tempSrcVal = ctx.data.attrs.src; ctx.data.attrs.src = val ? [] : ''; if(Array.isArray(ctx.data.attrs.src) && tempSrcVal) { ctx.data.attrs.src.push(tempSrcVal) } else if(Array.isArray(tempSrcVal) && tempSrcVal.length > 0) {ctx.data.attrs.src = tempSrcVal[0]};}",
                    col: 'col-6',
                  },
                  {
                    type: 'text',
                    default: '',
                    label: 'Src',
                    scope: 'attrs.src',
                    "call.hidden": "ctx.data.attrs.carousel",
                    col: 'col-12',
                    dataTransferTypeKey: 'type',
                    dataTransferValueKey: 'ident',
                    dataTransferType: 'image',
                    sideSlot: 'link',
                  },
                 {
                    type: "collection",
                    scope: "attrs.src",
                    defaultValue: '',
                    default: [],
                    "call.hidden": "!ctx.data.attrs.carousel",
                    keepReference: true,
                    seamless: true,
                    nested: {
                      item: [
                        {
                          innerText: "{{attrs.props.item.path}}"
                        }
                      ],
                      form: [
                        {
                          element: "NgFormInput",
                          sideSlot: 'link',
                          attrs: {
                            scope: "attrs.src.{{attrs.props.selectedIndex}}",
                            col: "col-12",
                            label: "Add a src...",
                            type: "text",
                            dataTransferTypeKey: 'type',
                            dataTransferValueKey: 'ident',
                            dataTransferType: 'image',
                          }
                        },
                      ]
                    }
                  },
                  {
                    type: 'checkbox',
                    default: false,
                    label: 'Autoplay',
                    scope: 'attrs.autoplay',
                    "call.hidden": "!ctx.data.attrs.carousel",
                    col: 'col-4',
                  },
                  {
                    type: 'checkbox',
                    default: true,
                    label: 'Navigation',
                    scope: 'attrs.navigation',
                    "call.hidden": "!ctx.data.attrs.carousel",
                    col: 'col-4',
                  },
                  {
                    type: 'checkbox',
                    default: true,
                    label: 'Arrows',
                    scope: 'attrs.arrows',
                    "call.hidden": "!ctx.data.attrs.carousel",
                    col: 'col-4',
                  },
                  {
                      type: 'color-palette',
                      default: 'primary',
                      label: 'Background',
                      scope: 'attrs.carouselBg',
                      "call.hidden": "!ctx.data.attrs.carousel",
                      col: 'col-12',
                      sideSlot: 'link',
                    },
                  {
                    type: 'text',
                    label: 'height',
                    scope: 'attrs.height',
                    col: 'col-6',
                  },
                  {
                    type: 'text',
                    label: 'width',
                    scope: 'attrs.width',
                    col: 'col-6',
                  },
                  {
                    type: 'select',
                    label: 'fit',
                    scope: 'attrs.fit',
                    col: 'col-12',
                    default: 'none',
                    options: [
                      { label: 'imageObjectFitCover', value: 'cover' },
                      { label: 'imageObjectFitFill', value: 'fill' },
                      { label: 'imageObjectFitContain', value: 'contain' },
                      { label: 'imageObjectFitNone', value: 'none' },
                      { label: 'imageObjectFitScaleDown', value: 'scale-down' },
                    ]
                  },
                  {
                    type: 'permissions',
                    default: [],
                    label: 'readPermissions',
                    hint: 'readPermissionsDescription',
                    scope: 'rights.read',
                    col: 'col-12',
                  },
                ]
              },
            }
          ]
        }
      ]
    },
    data() {
      return {
        carousel: false,
      }
    },
    // Define elements within the ui configuration...
    nodes() {
      return [
        {
          type: 'NgImage',
          props: {
            ...this.item.attrs,
          },
          children: {
            default: (slot) => {
              return [
                // child nodes or string content
              ]
            }
          },
        },
        // any ui component node can be used...
      ]
    },
  }
})