// Call ngui function to create a ui config.
window.ngui(() => {
  return {
      props: [
      'markdown',
      'design',
      'item',
      'computedObject',
      'panel',
    ],
    icon: 'mdi-movie',

        config: {
      startPanel: 'properties',
      panels: [
        {
          header: 'properties',
          name: 'properties',
          items: [
            {
              type: 'form',
              props: {
                scope: 'data',
                schema: [
                  {
                    type: 'text',
                    default: '',
                    label: 'Src',
                    scope: 'attrs.src',
                    col: 'col-12',
                    dataTransferTypeKey: 'type',
                    dataTransferValueKey: 'ident',
                    dataTransferType: 'file',
                    sideSlot: 'link',
                    hint: '.mp4 URL',
                  },
                 {
                    type: 'number',
                    default: 16,
                    label: 'widthRatio',
                    scope: 'attrs.widthRatio',
                    col: 'col-6',
                  },
                  {
                    type: 'number',
                    default: 9,
                    label: 'heightRatio',
                    scope: 'attrs.heightRatio',
                    col: 'col-6',
                  },
                  {
                    type: 'text',
                    label: 'width',
                    scope: 'attrs.width',
                    col: 'col-6',
                  },
                  {
                    type: 'permissions',
                    default: [],
                    label: 'readPermissions',
                    hint: 'readPermissionsDescription',
                    scope: 'rights.read',
                    col: 'col-12',
                  },
                ]
              },
            }
          ]
        }
      ]
    },	
    data() {
      return {
        carousel: false,
      }
    },
    // Define elements within the ui configuration...
    nodes() {
      return [
        {
          type: 'NgMediaVideo',
          props: {
            ...this.item.attrs,
          },
          children: {
            default: (slot) => {
              return [
                // child nodes or string content
              ]
            }
          },
        },
        // any ui component node can be used...
      ]
    },
  }
})